Index: /extensions/gvideo/language/tr_TR/index.php
===================================================================
--- /extensions/gvideo/language/tr_TR/index.php	(revision 17306)
+++ /extensions/gvideo/language/tr_TR/index.php	(revision 17307)
@@ -1,12 +1,9 @@
 <?php
 // +-----------------------------------------------------------------------+
-// | PhpWebGallery - a PHP based picture gallery                           |
-// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
-// | Copyright (C) 2003-2007 PhpWebGallery Team - http://phpwebgallery.net |
+// | Piwigo - a PHP based photo gallery                                    |
 // +-----------------------------------------------------------------------+
-// | file          : $Id$
-// | last update   : $Date$
-// | last modifier : $Author$
-// | revision      : $Revision$
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
 // +-----------------------------------------------------------------------+
 // | This program is free software; you can redistribute it and/or modify  |
Index: /extensions/gvideo/language/uk_UA/index.php
===================================================================
--- /extensions/gvideo/language/uk_UA/index.php	(revision 17307)
+++ /extensions/gvideo/language/uk_UA/index.php	(revision 17307)
@@ -0,0 +1,30 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based photo gallery                                    |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+// Recursive call
+$url = '../';
+header( 'Request-URI: '.$url );
+header( 'Content-Location: '.$url );
+header( 'Location: '.$url );
+exit();
+?>
Index: /extensions/gvideo/language/vi_VN/index.php
===================================================================
--- /extensions/gvideo/language/vi_VN/index.php	(revision 17306)
+++ /extensions/gvideo/language/vi_VN/index.php	(revision 17307)
@@ -1,12 +1,9 @@
 <?php
 // +-----------------------------------------------------------------------+
-// | PhpWebGallery - a PHP based picture gallery                           |
-// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
-// | Copyright (C) 2003-2007 PhpWebGallery Team - http://phpwebgallery.net |
+// | Piwigo - a PHP based photo gallery                                    |
 // +-----------------------------------------------------------------------+
-// | file          : $Id: index.php 1912 2007-03-16 06:30:07Z rub $
-// | last update   : $Date: 2007-03-16 07:30:07 +0100 (ven, 16 mar 2007) $
-// | last modifier : $Author: rub $
-// | revision      : $Revision: 1912 $
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
 // +-----------------------------------------------------------------------+
 // | This program is free software; you can redistribute it and/or modify  |
Index: /extensions/gvideo/language/zh_CN/index.php
===================================================================
--- /extensions/gvideo/language/zh_CN/index.php	(revision 17306)
+++ /extensions/gvideo/language/zh_CN/index.php	(revision 17307)
@@ -1,12 +1,9 @@
 <?php
 // +-----------------------------------------------------------------------+
-// | PhpWebGallery - a PHP based picture gallery                           |
-// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
-// | Copyright (C) 2003-2007 PhpWebGallery Team - http://phpwebgallery.net |
+// | Piwigo - a PHP based photo gallery                                    |
 // +-----------------------------------------------------------------------+
-// | file          : $Id$
-// | last update   : $Date$
-// | last modifier : $Author$
-// | revision      : $Revision$
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
 // +-----------------------------------------------------------------------+
 // | This program is free software; you can redistribute it and/or modify  |
Index: /extensions/gvideo/main.inc.php
===================================================================
--- /extensions/gvideo/main.inc.php	(revision 17306)
+++ /extensions/gvideo/main.inc.php	(revision 17307)
@@ -1,78 +1,39 @@
-<?php
+<?php 
 /*
-Plugin Name: PY GVideo
+Plugin Name: Embedded Videos
 Version: auto
-Description: Adds some videos from Google Video, Dailymotion, Youtube, Wideo, Vimeo or Wat.
+Description: Add videos from Dailymotion, Youtube, Vimeo, Wideo, videobb and Wat.
 Plugin URI: http://piwigo.org/ext/extension_view.php?eid=136
-Author: PYwaie & P@t
+Author: Mistic & P@t
+Author URI: http://www.strangeplanet.fr
 */
 
 if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
-define('GVIDEO_DIR' , basename(dirname(__FILE__)));
-define('GVIDEO_PATH' , PHPWG_PLUGINS_PATH . GVIDEO_DIR . '/');
 
-global $conf, $py_addext;
-$py_addext = array("gvideo", "dm", "ytube", "wideo", "vimeo", "wat");
-$conf['file_ext'] = array_merge($conf['file_ext'], $py_addext);
+global $prefixeTable;
 
-function gvideoadd($content)
+define('GVIDEO_PATH', PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');
+define('GVIDEO_ADMIN', get_root_url() . 'admin.php?page=plugin-' . basename(dirname(__FILE__)));
+define('GVIDEO_TABLE', $prefixeTable.'image_video');
+
+include(GVIDEO_PATH . 'include/gvideo.inc.php');
+
+add_event_handler('render_element_content', 'gvideo_element_content', EVENT_HANDLER_PRIORITY_NEUTRAL-10, 2);
+
+if (defined('IN_ADMIN'))
 {
-  global $page, $picture, $template, $py_addext, $conf;
+  add_event_handler('delete_elements', 'gvideo_delete_elements');
+  add_event_handler('loc_begin_admin_page', 'gvideo_photo_edit');
+  add_event_handler('get_admin_plugin_menu_links', 'gvideo_admin_menu');
 
-  if (!isset($picture['current']['file']))
-	{
-		return $content;
-	}
-  $extension = strtolower(get_extension($picture['current']['file']));
-  if (!in_array($extension, $py_addext) or $page['slideshow'])
-	{
-    return $content;
-	}
-	include_once( GVIDEO_PATH . '/gvideo.php');
-  return $content;
+  function gvideo_admin_menu($menu) 
+  {
+    array_push($menu, array(
+      'NAME' => 'Embedded Videos',
+      'URL' => GVIDEO_ADMIN,
+    ));
+    return $menu;
+  }
 }
 
-
-add_event_handler('get_thumbnail_location', 'py_mimetype', 60, 2);
-function py_mimetype($location, $element_info)
-{
-  if ( empty( $element_info['tn_ext'] ) )
-  {
-    global $py_addext;
-    $extension = strtolower(get_extension($element_info['path']));
-    if (in_array($extension, $py_addext))
-    {
-      $location= 'plugins/' . GVIDEO_DIR . '/mimetypes/' . $extension . '.png';
-    }
-  }
-  return $location;
-}
-
-add_event_handler('get_mimetype_location', 'py_mimetype_location', 60, 2);
-function py_mimetype_location($location, $ext)
-{
-  global $py_addext;
-  if (in_array($ext, $py_addext))
-  {
-    $location= 'plugins/' . GVIDEO_DIR . '/mimetypes/' . $ext . '.png';
-  }
-  return $location;
-}
-
-if (script_basename() == 'admin')
-{
-	add_event_handler('get_admin_plugin_menu_links', 'gvideo_admin_menu');
-	
-	function gvideo_admin_menu($menu)
-	{
-		array_push($menu, array(
-			'NAME' => 'PY GVideo',
-			'URL' => get_admin_plugin_menu_link( GVIDEO_PATH . '/admin/pywaie_admin.php')));
-		return $menu;
-	}
-}
-
-add_event_handler('render_element_content', 'gvideoadd');
-add_event_handler('get_thumbnail_location', 'py_mimetype', 60, 2);
-
 ?>
Index: /extensions/gvideo/maintain.inc.php
===================================================================
--- /extensions/gvideo/maintain.inc.php	(revision 17306)
+++ /extensions/gvideo/maintain.inc.php	(revision 17307)
@@ -1,50 +1,228 @@
 <?php
-
-function plugin_install()
+if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+
+global $prefixeTable;
+
+define('gvideo_path', PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)));
+define('gvideo_table', $prefixeTable.'image_video');
+
+define(
+  'gvideo_default_config', 
+  serialize(array(
+    'autoplay' => 0,
+    'width' => 640,
+    'height' => 360,
+    'vimeo' => array(
+      'title' => 1,
+      'portrait' => 1,
+      'byline' => 1,
+      'color' => '00adef',
+      ),
+    'dailymotion' => array(
+      'logo' => 1,
+      'title' => 1,
+      'color' => 'F7FFFD',
+      ),
+    'youtube' => array(),
+    'wat' => array(),
+    'wideo' => array(),
+    'videobb' => array(),
+    ))
+  );
+
+
+function plugin_install() 
 {
-  $params = array(
-    'gvideo' => array('480','640','true','en'),
-    'ytube' => array('480','640','1'),
-    'dm' =>  array('480','640','1'),
-    'wideo' => array('480', '640', 'true'),
-    'vimeo' => array('480', '640', '1'),
-    'wat' => array('480', '640', 'true'),
-    );
-
-	$q = 'REPLACE INTO ' . CONFIG_TABLE . ' (param,value,comment)
-VALUES ("PY_GVideo","' . addslashes(serialize($params)) . '" , "PY Gvideo plugin parameters");';
-  pwg_query($q);
-}
-
-// La table de config se met à jour automatiquemlent lors de l'activation
+  global $conf;
+  
+  conf_update_param('gvideo', gvideo_default_config);
+  
+  $query = '
+CREATE TABLE IF NOT EXISTS `'.gvideo_table.'` (
+  `picture_id` mediumint(8) NOT NULL,
+  `type` varchar(64) NOT NULL,
+  `video_id` varchar(64) NOT NULL,
+  `width` smallint(9) DEFAULT NULL,
+  `height` smallint(9) DEFAULT NULL,
+  `autoplay` tinyint(1) DEFAULT NULL
+) ENGINE=MyISAM DEFAULT CHARSET=utf8
+;';
+  pwg_query($query);
+  
+  if (isset($conf['PY_GVideo']))
+  {
+    pwg_query('DELETE FROM `'. CONFIG_TABLE .'` WHERE param = "PY_GVideo" LIMIT 1;');
+    unset($conf['PY_GVideo']);
+  
+    gvideo_update_24();
+  }
+}
+
 function plugin_activate()
 {
   global $conf;
-
-  // Suppression des anciens paramètres (version < 1.7.o)
-  if (isset($conf['pywaie_gvideo']))
-  {
-    pwg_query('DELETE FROM ' . CONFIG_TABLE . ' WHERE param LIKE "pywaie_%";');
-  }
-  
-  // Vérification des nouveaux paramètres
-  if (!isset($conf['PY_GVideo'])
-    or ($params = unserialize($conf['PY_GVideo']) and !isset($params['wat'])))
+    
+  if (isset($conf['PY_GVideo']))
   {
     plugin_install();
   }
-}
-
-function plugin_uninstall()
+  else if (!isset($conf['gvideo']))
+  {
+    conf_update_param('gvideo', gvideo_default_config);
+  }
+}
+
+function plugin_uninstall() 
+{  
+  pwg_query('DELETE FROM `'. CONFIG_TABLE .'` WHERE param = "gvideo" LIMIT 1;');
+  pwg_query('DROP TABLE `'.gvideo_table.'`;');
+}
+
+
+/**
+ * update from 2.3 to 2.4
+ */
+function gvideo_update_24()
 {
   global $conf;
   
-  // Suppression des anciens paramètres (version < 1.7.o)
-  if (isset($conf['pywaie_gvideo']))
-  {
-    pwg_query('DELETE FROM ' . CONFIG_TABLE . ' WHERE param LIKE "pywaie_%";');
-  }
-
-  pwg_query('DELETE FROM ' . CONFIG_TABLE . ' WHERE param = "PY_GVideo";');
+  // search existing videos
+  $query = '
+SELECT *
+  FROM '.IMAGES_TABLE.'
+  WHERE
+    file LIKE "%.gvideo"
+    OR file LIKE "%.dm"
+    OR file LIKE "%.ytube"
+    OR file LIKE "%.wideo"
+    OR file LIKE "%.vimeo"
+    OR file LIKE "%.wat"
+;';
+  $result = pwg_query($query);
+  
+  if (!pwg_db_num_rows($result))
+  {
+    return;
+  }
+  
+  set_time_limit(600);
+  include_once(gvideo_path . '/include/functions.inc.php');
+  include_once(PHPWG_ROOT_PATH . 'admin/include/functions_upload.inc.php');
+  
+  $videos_inserts = array();
+  $images_updates = array();
+  $images_delete = array();
+  
+  while ($img = pwg_db_fetch_assoc($result))
+  {
+    $file_content = file_get_contents($img['path']);
+    list($file['id'], $file['height'], $file['width'], ) = explode('/', $file_content);
+    $file['type'] = get_extension($img['path']);
+    
+    switch ($file['type'])
+    {
+      case 'vimeo':
+        $url = 'http://vimeo.com/'.$file['id'];
+        break;
+      case 'dm':
+        $url = 'http://dailymotion.com/video/'.$file['id'];
+        break;
+      case 'ytube':
+        $url = 'http://youtu.be/'.$file['id'];
+        break;
+      case 'wideo':
+        $url = 'http://wideo.fr/video/'.$file['id'].'.html';
+        break;
+        
+      case 'wat': // can't get original page from id !
+        $thumb = str_replace($img['file'], null, $img['path']).'thumbnail/TN-'.get_filename_wo_extension($img['file']).'.*';
+        $thumb = glob($thumb);
+        if (!empty($thumb))
+        {
+          $thumb_name = 'wat-'.$file['id'].'-'.uniqid().'.'.get_extension($thumb[0]);
+          $thumb_source = $conf['data_location'].$thumb_name;
+          copy($thumb[0], $thumb_source);
+        }
+        
+        $video = array(
+          'type' => 'wat',
+          'id' => $file['id'],
+          'title' => null,
+          'description' => null,
+          'thumbnail' => null,
+          );
+        break;
+        
+      case 'gvideo': // closed
+      default:
+        array_push($images_delete, $img['id']);
+        continue;
+    }
+    
+    // get video infos
+    if (!isset($video))
+    {
+      if ( ($video = parse_video_url($url)) === false )
+      {
+        array_push($images_delete, $img['id']);
+        continue;
+      }
+    }
+    
+    // download thumbnail
+    if (!isset($thumb_source))
+    {
+      $thumb_name = $video['type'].'-'.$video['id'].'-'.uniqid().'.'.get_extension($video['thumbnail']);
+      $thumb_source = $conf['data_location'].$thumb_name;
+      if (download_remote_file($video['thumbnail'], $thumb_source) !== true)
+      {
+        $thumb_source = $conf['data_location'].get_filename_wo_extension($thumb_name).'.jpg';
+        copy(gvideo_path.'mimetypes/'.$video['type'].'.jpg', $thumb_source);
+      }
+    }
+    
+    // update element
+    $image_id = add_uploaded_file($thumb_source, $thumb_name, null, null, $img['id']);
+    
+    // update path and rename the file
+    $img['new_path'] = str_replace($img['file'], null, $img['path']).$thumb_name;
+    rename($img['path'], $img['new_path']);
+    array_push($images_updates, array(
+      'id' => $img['id'],
+      'path' => str_replace('././', './', $img['new_path']),
+      ));
+    
+    if (empty($file['width'])) $file['width'] = '';
+    if (empty($file['height'])) $file['height'] = '';
+    
+    // register video    
+    array_push($videos_inserts, array(
+      'picture_id' => $image_id,
+      'type' => $video['type'],
+      'video_id' => $video['id'],
+      'width' => $file['width'],
+      'height' => $file['height'],
+      'autoplay' => '',
+      ));
+      
+    unset($thumb_source, $thumb_name, $file, $video, $url);
+  }
+  
+  // delete obsolete elements
+  delete_elements($images_delete);
+  
+  // registers videos
+  mass_inserts(
+    gvideo_table,
+    array('picture_id', 'type', 'video_id', 'width', 'height', 'autoplay'),
+    $videos_inserts
+    );
+    
+  // update images
+  mass_updates(
+    IMAGES_TABLE,
+    array('primary'=>array('id'), 'update'=>array('path')),
+    $images_updates
+    );
 }
 
Index: /extensions/gvideo/mimetypes/index.php
===================================================================
--- /extensions/gvideo/mimetypes/index.php	(revision 17306)
+++ /extensions/gvideo/mimetypes/index.php	(revision 17307)
@@ -1,12 +1,9 @@
 <?php
 // +-----------------------------------------------------------------------+
-// | PhpWebGallery - a PHP based picture gallery                           |
-// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
-// | Copyright (C) 2003-2007 PhpWebGallery Team - http://phpwebgallery.net |
+// | Piwigo - a PHP based photo gallery                                    |
 // +-----------------------------------------------------------------------+
-// | file          : $Id: index.php 1912 2007-03-16 06:30:07Z rub $
-// | last update   : $Date: 2007-03-16 07:30:07 +0100 (ven, 16 mar 2007) $
-// | last modifier : $Author: rub $
-// | revision      : $Revision: 1912 $
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
 // +-----------------------------------------------------------------------+
 // | This program is free software; you can redistribute it and/or modify  |
